=== debian/changelog ===
libyang (0.16.105-3build1) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:20:45 +0100

libyang (0.16.105-3) unstable; urgency=medium

  * work around parallel build issues with python bindings (build only change)

 -- David Lamparter <equinox-debian@diac24.net>  Mon, 20 Jan 2020 17:20:21 +0100

libyang (0.16.105-2) unstable; urgency=medium

  * fix CVE-2019-19333 & CVE-2019-19334 (Closes: #946217)
  * fix cache corruption crash (upstream bug 752)
  * fix some gcc & swig version dependent build failures (Closes: #925764)

 -- David Lamparter <equinox-debian@diac24.net>  Sun, 22 Dec 2019 14:27:01 +0100

libyang (0.16.105-1) unstable; urgency=medium

  * upstream 0.16.105 (0.16-r3) release

 -- David Lamparter <equinox-debian@diac24.net>  Wed, 23 Jan 2019 01:32:43 +0100

libyang (0.16.52-2) unstable; urgency=medium

  * use correct DEB_HOST_GNU_TYPE to fix i386 build
  * mark non-libyang C++ symbols as optional (fixes build on several arch)
  * pull in 2 upstraem fixes to get build working on big-endian

 -- David Lamparter <equinox-debian@diac24.net>  Thu, 06 Dec 2018 13:33:08 +0100

libyang (0.16.52-1) unstable; urgency=medium

  * Initial release.
  * Closes: #913219

 -- David Lamparter <equinox-debian@diac24.net>  Sun, 18 Nov 2018 19:30:04 +0100
