=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:String="Package" \
		-DENABLE_LYD_PRIV=ON \
		-DGEN_LANGUAGE_BINDINGS=ON \
		-DGEN_JAVA_BINDINGS=OFF \
		-DGEN_JAVASCRIPT_BINDINGS=OFF \
		-DGEN_PYTHON_VERSION=`/usr/bin/py3versions -s | sed \
			-e 's/python\(3\.[0-7]\)/\1;\1dm/g' \
			-e 's/python\([^ ]\+\)/\1;\1d/g' \
			-e 's/ /;/g'`

# building the SWIG generated Python bindings uses >= 1.5GB RAM per each
# g++ process, and this will be attempted in parallel.  Just build these bits
# in sequence to avoid OOM build failures.

override_dh_auto_build:
	dh_auto_build -- yang libyang-cpp
	set -e; /usr/bin/py3versions -s | sed \
			-e 's/python\(3\.[0-7]\)/\1 \1dm/g' \
			-e 's/python\([^ ]\+\)/\1 \1d/g' \
			-e 's/ /\n/g' | while read V; do \
		dh_auto_build --no-parallel -- _yang$${V}; \
	done
	dh_auto_build

override_dh_auto_install:
	dh_auto_install
	-rm -rf debian/tmp/usr/lib/python3
	set -e; /usr/bin/py3versions -s | sed -e 's/python\([^ ]\+\)/\1/g' -e 's/ /\n/g' | while read V; do \
		make -C obj-$(DEB_HOST_GNU_TYPE)/swig/python$${V} DESTDIR=`pwd`/debian/python3-yang     install; \
	done
	set -e; /usr/bin/py3versions -s | sed -e 's/python\(3\.[0-7]\)/\1dm/g' -e 's/python\([^ ]\+\)/\1d/g' -e 's/ /\n/g' | while read V; do \
		make -C obj-$(DEB_HOST_GNU_TYPE)/swig/python$${V} DESTDIR=`pwd`/debian/python3-yang-dbg install; \
	done
	-rm -rf debian/python3-yang/usr/include
	-rm -rf debian/python3-yang-dbg/usr/include

override_dh_strip:
	dh_strip -Npython3-yang-dbg -Npython3-yang
	dh_strip -ppython3-yang --dbg-package=python3-yang-dbg

override_dh_makeshlibs:
	dh_makeshlibs -Xextensions -Xuser_types

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	make -C obj-$(DEB_HOST_GNU_TYPE) test ARGS=-V
endif
