## libyang 0.16.105+really1.0

=== debian/changelog ===
libyang (0.16.105+really1.0-0+deb10u1) buster-security; urgency=high

  * Non-maintainer upload by the LTS team.
  * Backport Bullseye version of libyang to facilitate security update of frr.
  * Fix CVE-2019-20391, CVE-2019-20392, CVE-2019-20393, CVE-2019-20394,
    CVE-2019-20395, CVE-2019-20396, CVE-2019-20397, CVE-2019-20398.
    Multiple flaws were found in libyang, a parser toolkit for IETF YANG data
    modeling. Double frees, invalid memory access and Null pointer dereferences
    may cause a denial of service or potentially code execution.

 -- Markus Koschany <apo@debian.org>  Tue, 19 Sep 2023 17:53:50 +0200

libyang (0.16.105-1+deb10u1) buster; urgency=medium

  * Fix CVE-2019-19333 & CVE-2019-19334 (Closes: #946217)
  * Fix cache corruption crash (upstream bug 752)

 -- Ondřej Surý <ondrej@debian.org>  Tue, 12 May 2020 09:02:56 +0200
