=== debian/control ===
--- 
+++ 
@@ -9,12 +9,8 @@
  bison,
  cmake,
  debhelper (>= 11~),
- dh-python,
  libcmocka-dev <!nocheck>,
  libpcre3-dev,
- swig (>= 3.0.12),
- python3-all-dev,
- python3-all-dbg,
  pkg-config
 Vcs-Browser: https://github.com/CESNET/libyang/tree/debian
 Vcs-Git: https://github.com/CESNET/libyang.git -b debian
@@ -94,30 +90,3 @@
  This is the accompanying development package, containing headers, a
  pkgconfig file, and .so entry point for the libyang C++ bindings.
 
-Package: python3-yang
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
- ${python3:Depends},
- libyang-cpp0.16 (= ${binary:Version})
-Section: python
-Architecture: any
-Description: parser toolkit for IETF YANG data modeling - python3 support
- This package allows using libyang functionality to load IETF YANG models
- and data from Python3 code.
- .
- The bindings are partially generated by SWIG.
-
-Package: python3-yang-dbg
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
- ${python3:Depends},
- python3-yang (=${binary:Version})
-Section: debug
-Architecture: any
-Description: parser toolkit for IETF YANG data modeling - python3 debug
- This package allows using libyang functionality to load IETF YANG models
- and data from Python3 code.
- .
- This package contains support for debug versions of Python.
