## libyang 1.0.184

=== debian/changelog ===
libyang (1.0.184-2ubuntu1) groovy; urgency=medium

  * Drop Python autopkgtest since python3-yang is not built anymore

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 15 Sep 2020 18:59:51 +0200

libyang (1.0.184-2) unstable; urgency=medium

  * Move the C++ symbols file to be amd64 only (Closes: #969073)

 -- Ondřej Surý <ondrej@debian.org>  Fri, 04 Sep 2020 10:16:16 +0200

libyang (1.0.184-1) unstable; urgency=medium

  * Remove upstream patches merged upstream
  * Update changelog for 1.0.184-1~1.gbp418b5c release
  * Update symbols files for libyang_1.0.184

 -- Ondřej Surý <ondrej@debian.org>  Tue, 21 Jul 2020 16:36:41 +0200

libyang (1.0.176-3) unstable; urgency=medium

  * Add upstream patch for 'data tree BUGFIX hash canonical values for leaves'

 -- Ondřej Surý <ondrej@debian.org>  Sun, 19 Jul 2020 11:00:20 +0200

libyang (1.0.176-2) unstable; urgency=medium

  * Make the C++ symbols human readable
  * Mark symbols missing on Debian jessie as optional
  * Renamed yang-tools package to libyang-tools

 -- Ondřej Surý <ondrej@debian.org>  Wed, 15 Jul 2020 09:35:56 +0200

libyang (1.0.176-1) unstable; urgency=medium

  * New upstream release
  * Add SymbolsHelper-Confirmed header
  * Update symbols files for libyang 1.0.176

 -- Ondřej Surý <ondrej@debian.org>  Mon, 08 Jun 2020 11:21:04 +0200

libyang (1.0.167-1) experimental; urgency=medium

  [ David Lamparter ]
  * major version bump (0.16 -> 1.0)

  [ Ondřej Surý ]
  * Add d/gbp.conf
  * Add README.source on how to work with upstream repository
  * Rediff patches
  * Drop the python bindings
  * Use pkg-kde-tools to regenerate symbols
  * Lower the dh_compat level to 10
  * Add lintian-overrides for the plugins
  * Move the maintainer notes to README.source
  * Add myself to uploaders
  * Add extensions to the libyang1.symbols file

 -- Ondřej Surý <ondrej@debian.org>  Fri, 22 May 2020 10:54:51 +0200
