=== debian/control ===
--- 
+++ 
@@ -1,24 +1,24 @@
 Source: libyang
 Section: libs
 Homepage: https://netopeer.liberouter.org/
-Maintainer: David Lamparter <equinox-debian@diac24.net>
-Uploaders: CESNET <rkrejci@cesnet.cz>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: David Lamparter <equinox-debian@diac24.net>
+Uploaders: CESNET <rkrejci@cesnet.cz>,
+           Ondřej Surý <ondrej@debian.org>
 Priority: optional
-Standards-Version: 4.2.1
-Build-Depends:
- bison,
- cmake,
- debhelper (>= 11~),
- libcmocka-dev <!nocheck>,
- libpcre3-dev,
- pkg-config
-Vcs-Browser: https://github.com/CESNET/libyang/tree/debian
-Vcs-Git: https://github.com/CESNET/libyang.git -b debian
+Standards-Version: 4.5.0
+Build-Depends: bison,
+               cmake,
+               debhelper (>= 9.20150101),
+               libcmocka-dev <!nocheck>,
+               libpcre3-dev,
+               pkg-config
+Vcs-Browser: https://github.com/CESNET/libyang/tree/debian/master
+Vcs-Git: https://github.com/CESNET/libyang.git -b debian/master
 
-Package: libyang0.16
-Depends:
- ${misc:Depends},
- ${shlibs:Depends}
+Package: libyang1
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - runtime
  Libyang implements functions to process schemas expressed in the
@@ -33,10 +33,9 @@
  to use in processing configurations.
 
 Package: libyang-dev
-Depends:
- ${misc:Depends},
- libpcre3-dev,
- libyang0.16 (= ${binary:Version})
+Depends: libpcre3-dev,
+         libyang1 (= ${binary:Version}),
+         ${misc:Depends}
 Section: libdevel
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - development files
@@ -51,11 +50,12 @@
  This package contains the C headers, a pkgconfig file, and .so entry point
  for libyang.
 
-Package: yang-tools
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
- libyang0.16 (= ${binary:Version})
+Package: libyang-tools
+Depends: libyang1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
+Breaks: yang-tools (<< ${source:Version})
+Replaces: yang-tools (<< ${source:Version})
 Section: devel
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - executable tools
@@ -64,11 +64,10 @@
  useful for normal operation where libyang primarily processes configuration
  data, not schemas.
 
-Package: libyang-cpp0.16
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
- libyang0.16 (= ${binary:Version})
+Package: libyang-cpp1
+Depends: libyang1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - C++ runtime
  Partially SWIG-generated bindings to use libyang with a C++ API.
@@ -76,10 +75,9 @@
  and uses libyang C code.
 
 Package: libyang-cpp-dev
-Depends:
- ${misc:Depends},
- libyang-cpp0.16 (= ${binary:Version}),
- libyang-dev (= ${binary:Version})
+Depends: libyang-cpp1 (= ${binary:Version}),
+         libyang-dev (= ${binary:Version}),
+         ${misc:Depends}
 Section: libdevel
 Architecture: any
 Description: parser toolkit for IETF YANG data modeling - C++ development files
@@ -90,3 +88,11 @@
  This is the accompanying development package, containing headers, a
  pkgconfig file, and .so entry point for the libyang C++ bindings.
 
+Package: yang-tools
+Depends: libyang-tools (>= ${source:Version}),
+         ${misc:Depends}
+Section: oldlibs
+Architecture: all
+Description: parser toolkit for IETF YANG data modeling [dummy package]
+ This is empty dependency package to pull the executable tools.  It's
+ safe to remove.
